unit U_MCGRKList_THCK;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ToolWin, cxStyles, cxCustomData,
  cxGraphics, cxFilter, cxData, cxDataStorage, cxEdit, DB, cxDBData, ADODB,
  cxGridCustomPopupMenu, cxGridPopupMenu, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridCustomTableView, cxGridTableView,
  cxGridDBTableView, cxGrid, DBClient, cxCheckBox, cxCalendar, cxSplitter,
  RM_Dataset, RM_System, RM_Common, RM_Class, RM_GridReport, RM_e_Xls,
  Menus, cxButtonEdit, cxDropDownEdit, cxPC, Buttons, cxContainer,
  cxGroupBox, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdFTP,ShellAPI, ImgList,StrUtils, cxLookAndFeels, cxLookAndFeelPainters,
  dxSkinsCore,    
   dxSkinDarkRoom,  
    
     
    
    
    
    
   
   dxSkinOffice2013White, 
     dxSkinSharpPlus,
   dxSkinSpringTime,  
   dxSkinsDefaultPainters, 
     dxSkinscxPCPainter,
  cxNavigator;

type
  TfrmMCGRKList_THCK = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBAdd: TToolButton;
    TBClose: TToolButton;
    Tv1: TcxGridDBTableView;
    cxGrid1Level1: TcxGridLevel;
    cxGrid1: TcxGrid;
    cxGridPopupMenu1: TcxGridPopupMenu;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;                  
    ADOQueryTemp: TADOQuery;
    DataSource1: TDataSource;
    TBExport: TToolButton;
    Order_Main: TClientDataSet;
    ToolButton1: TToolButton;
    Panel1: TPanel;
    v1Column1: TcxGridDBColumn;
    Label34: TLabel;
    v1Column7: TcxGridDBColumn;
    v1Column9: TcxGridDBColumn;
    KHNameJC: TEdit;
    BegDate: TDateTimePicker;
    EndDate: TDateTimePicker;
    ToolButton4: TToolButton;
    RM1: TRMGridReport;
    RMDBMain: TRMDBDataSet;
    RMXLSExport2: TRMXLSExport;
    CDS_PRT: TClientDataSet;
    v1Column17: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    labMYType: TLabel;
    Panel4: TPanel;
    SpeedButton1: TSpeedButton;
    Image2: TImage;
    v1MYType: TcxGridDBColumn;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    CheckBox1: TCheckBox;
    Button2: TButton;
    v1MYMDMoney: TcxGridDBColumn;
    v1JCDanWeiJC: TcxGridDBColumn;
    Label3: TLabel;
    JCDanWeiJC: TEdit;
    Button1: TButton;
    Label4: TLabel;
    filler: TEdit;
    v1filler: TcxGridDBColumn;
    cxGroupBox2: TcxGroupBox;
    ListView1: TListView;
    Panel12: TPanel;
    Label8: TLabel;
    Button4: TButton;
    Panel13: TPanel;
    Image1: TImage;
    WJName: TEdit;
    Button7: TButton;
    WJPach: TEdit;
    Button8: TButton;
    Panel2: TPanel;
    v1IFFZ: TcxGridDBColumn;
    ODPat: TOpenDialog;
    IdFTP1: TIdFTP;
    PopupMenu2: TPopupMenu;
    MenuItem1: TMenuItem;
    N3: TMenuItem;
    MenuItem2: TMenuItem;
    N4: TMenuItem;
    Label2: TLabel;
    Label1: TLabel;
    MYName: TEdit;
    Note: TEdit;
    Button3: TButton;
    ImageList1: TImageList;
    v1RKNo: TcxGridDBColumn;
    Image3: TImage;
    v1editer: TcxGridDBColumn;
    KHNo: TEdit;
    JCKHNo: TEdit;
    v1GFOrderNo: TcxGridDBColumn;
    N5: TMenuItem;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure TBAddClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure CustomerNoNameChange(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
    procedure ZJStatusChange(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure Tv1DblClick(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure Image3Click(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
  private
    canshu1:string;
    DQdate:TDateTime;
    procedure InitGrid();
    procedure InitForm();
    function  DelData():Boolean;
    procedure Initimage();
    { Private declarations }
  public
    FFInt,FCloth:Integer;
    { Public declarations }
  end;

var
  frmMCGRKList_THCK: TfrmMCGRKList_THCK;

implementation
uses
  U_DataLink,U_RTFun, U_QCRKInPut,U_ZDYHelp,U_LLRKInPut,U_GYSList,U_LLRKInPutMH_MCG,U_LLRKInPutMH_MTHCK_CS,
  U_LLRKInPutMH,U_LLRKInPutX,U_LLRKInPut_CG,U_LLRKInPutMH_CG,U_BPZdy_LRM,U_LLRKInPutMH_MTHCK,U_MCGRKList_CX,
  U_PMCGRKList_CX;

{$R *.dfm}

procedure TfrmMCGRKList_THCK.FormDestroy(Sender: TObject);
begin
  frmMCGRKList_THCK:=nil;
end;

procedure TfrmMCGRKList_THCK.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfrmMCGRKList_THCK.FormCreate(Sender: TObject);
begin
  cxgrid1.Align:=alClient;
  canshu1:=Trim(DParameters1);
end;

procedure TfrmMCGRKList_THCK.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('棉采购入库退货1',Tv1,'贸易生产管理');
  Close;
end;

procedure TfrmMCGRKList_THCK.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered:=False;
      Close;
      sql.Clear;
      sql.Add(' select A.CRTime,A.GFOrderNo,A.filler,A.Editer,A.MYType,A.RKNo,A.KHName,A.JCDanWei,A.MYTypeFlag');
      SQL.ADD(',Sum(PS) PS,Sum(KgQty) KgQty,Sum(Qty) Qty,Sum(MYMDMoney) MYMDMoney ');
      sql.add(',IFFZ=(select Count(B.WBID) from TP_File B where B.WBID=A.RKNo and B.TFType=''退货棉'')');
      sql.Add(',KHNameJC=(select Top 1 B.KHNameJC from KH_Main B ');
      sql.Add(' where isnull(B.KHFlag,'''')=''GYS'' and isnull(B.Valid,'''')=''Y'' and B.KHName=A.KHName)');
      sql.Add(',JCDanWeiJC=(select Top 1 B.KHNameJC from KH_Main B ');
      sql.Add(' where isnull(B.KHFlag,'''')=''GS'' and isnull(B.Valid,'''')=''Y'' and B.KHName=A.JCDanWei)');
      sql.Add(',KHNo=(select Top 1 B.KHNo from KH_Main B ');
      sql.Add(' where isnull(B.KHFlag,'''')=''GYS'' and isnull(B.Valid,'''')=''Y'' and B.KHName=A.KHName)');
      sql.Add(',JCKHNo=(select Top 1 B.KHNo from KH_Main B ');
      sql.Add(' where isnull(B.KHFlag,'''')=''GYS'' and isnull(B.Valid,'''')=''Y'' and B.KHName=A.JCDanWei)');
      sql.Add(' from CK_MYSC_CR A  ');
      sql.Add(' where 1=1 ');
      if CheckBox1.Checked=False then
      begin
        sql.Add(' and A.CRTime>='''+Trim(FormatDateTime('yyyy-MM-dd',now))+'''');
        sql.Add(' and A.CRTime<'''+Trim(FormatDateTime('yyyy-MM-dd',now+1))+'''');
        BegDate.Visible:=false;
        EndDate.Visible:=false;
      end
      else
      begin
        sql.Add(' and A.CRTime>='''+Trim(FormatDateTime('yyyy-MM-dd',BegDate.Date))+'''');
        sql.Add(' and A.CRTime<'''+Trim(FormatDateTime('yyyy-MM-dd',EndDate.Date+1))+'''');
        BegDate.Visible:=true;
        EndDate.Visible:=true;
      end;
      sql.Add(' and isnull(CRType,'''')=''退货出库'' ');
      SQL.Add(' and isnull(MYTypeFlag,'''')=''CGH''');
      SQL.Add(' group by A.CRTime,A.GFOrderNo,A.RKNo,A.filler,A.Editer,A.MYType,A.KHName,A.JCDanWei,A.MYTypeFlag');
      Open;
    end;
    SCreateCDS20(ADOQueryMain,Order_Main);
    SInitCDSData20(ADOQueryMain,Order_Main);
  finally
    ADOQueryMain.EnableControls;
  end;
end;


procedure TfrmMCGRKList_THCK.InitForm();
begin
  BegDate.Date:=SGetServerDateMBeg(ADOQueryTemp);
  EndDate.Date:=SGetServerDate(ADOQueryTemp);
  ReadCxGrid('棉采购入库退货1',Tv1,'贸易生产管理');
  InitGrid();
end;

procedure TfrmMCGRKList_THCK.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active=False then Exit;
  SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
end;

function TfrmMCGRKList_THCK.DelData():Boolean;
begin
  try
    Result:=false;
    ADOQueryCmd.Connection.BeginTrans;
    Order_Main.DisableControls;
    with Order_Main do
    begin
      //First;
     // while Order_Main.Locate('SSel',True,[]) do
      begin
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add(' delete from YS_Money_CR where YFTypeId in (select B.MYID ');
          SQL.Add(' from CK_MYSC_CR B where B.RKNO='''+trim(Order_Main.fieldbyname('RKNO').AsString)+''') ');
          sql.Add(' delete from TP_File where WBID='''+trim(Order_Main.fieldbyname('RKNO').AsString)+''' ');
          sql.Add(' and TFType=''退货棉''');
          sql.Add(' insert into CK_MYSC_CR_Log  ');
          sql.Add(' select * from CK_MYSC_CR where RKNO='''+Trim(Order_Main.fieldbyname('RKNO').AsString)+'''');
          sql.Add(' UPdate CK_MYSC_CR_Log Set DelTime=getdate(),DelerCode='''+Trim(DCode)+''',Deler='''+Trim(DName)+'''');
          sql.Add(' where RKNO='''+Trim(Order_Main.fieldbyname('RKNO').AsString)+'''');
          sql.Add(' Delete CK_MYSC_CR  where RKNO='''+Trim(Order_Main.fieldbyname('RKNO').AsString)+'''');
          ExecSQL;
        end;
        Order_Main.Delete;
      end;
    end;
    Order_Main.EnableControls;
    ADOQueryCmd.Connection.CommitTrans;
    Result:=True;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    Result:=False;
    Application.MessageBox('数据删除异常！','提示',0);
  end;
end;

procedure TfrmMCGRKList_THCK.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then Exit;
  TcxGridToExcel(Self.Caption,cxGrid1);
end;

procedure TfrmMCGRKList_THCK.TBRafreshClick(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmMCGRKList_THCK.TBAddClick(Sender: TObject);
begin
  SpeedButton1.Click;
end;

procedure TfrmMCGRKList_THCK.FormShow(Sender: TObject);
begin
  InitForm();
end;

procedure TfrmMCGRKList_THCK.CheckBox1Click(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmMCGRKList_THCK.CheckBox2Click(Sender: TObject);
begin
  TBRafresh.Click;
end;

procedure TfrmMCGRKList_THCK.ToolButton1Click(Sender: TObject);
begin
  try
    frmLLRKInPutMH_MTHCK:=TfrmLLRKInPutMH_MTHCK.Create(Application);
    with frmLLRKInPutMH_MTHCK do
    begin
      PState:=1;
      FMainId:=Trim(Self.Order_Main.fieldbyname('RKNo').AsString);
      FMYType:=Trim(Self.Order_Main.fieldbyname('MYType').AsString);
      FMYTypeFlag:=Trim(Self.Order_Main.fieldbyname('MYTypeFlag').AsString);
      TBSave.Visible:=False;
      cxGrid2.Visible:=false;
      labMYType.Caption:='(棉)采购';
      PopupMenu1.Items.Clear;
      if ShowModal=1 then
      begin
        InitGrid();
      end;
    end;
  finally
    frmLLRKInPutMH_MTHCK.Free;
  end;
end;

procedure TfrmMCGRKList_THCK.CustomerNoNameChange(Sender: TObject);
begin
  if ADOQueryMain.Active=False then Exit;
  SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
end;

procedure TfrmMCGRKList_THCK.N2Click(Sender: TObject);
begin
  if Order_Main.IsEmpty then Exit;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select A.* from YS_Money_CR A where A.YFTypeId in (select B.MYID from CK_MYSC_CR B where B.RKNo='''+Trim(Self.Order_Main.fieldbyname('RKNo').AsString)+''') ');
    sql.Add('and A.ChkStatusP=''已审核''');
    Open;
  end;
  if ADOQueryTemp.IsEmpty=false then
  begin
    Application.MessageBox('应付款已审核不能操作','提示');
    exit;
  end;
  if Application.MessageBox('确定要删除数据吗？','提示',32+4)<>IDYES then Exit;
  if DelData() then
  begin
    //Order_Main.Delete;
  end;
end;

procedure TfrmMCGRKList_THCK.N1Click(Sender: TObject);
var
  FFMYType:String;
begin
  if Order_Main.IsEmpty then Exit;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select A.* from YS_Money_CR A where A.YFTypeId in (select B.MYID from CK_MYSC_CR B where B.RKNo='''+Trim(Self.Order_Main.fieldbyname('RKNo').AsString)+''') ');
    sql.Add('and A.ChkStatusP=''已审核''');
    Open;
  end;
  if ADOQueryTemp.IsEmpty=false then
  begin
    Application.MessageBox('应付款已审核不能操作','提示');
    exit;
  end;
  try
    frmLLRKInPutMH_MTHCK:=TfrmLLRKInPutMH_MTHCK.Create(Application);
    with frmLLRKInPutMH_MTHCK do
    begin
      PState:=1;
      FMainId:=Trim(Self.Order_Main.fieldbyname('RKNo').AsString);
      FMYType:=Trim(Self.Order_Main.fieldbyname('MYType').AsString);
      FMYTypeFlag:=Trim(Self.Order_Main.fieldbyname('MYTypeFlag').AsString);
      labMYType.Caption:='(棉)采购';
      cxGrid2.Visible:=false;
      if ShowModal=1 then
      begin
        InitGrid();
      end;
    end;
  finally
    frmLLRKInPutMH_MTHCK.Free;
  end;
end;

procedure TfrmMCGRKList_THCK.cxTabControl1Change(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmMCGRKList_THCK.ZJStatusChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmMCGRKList_THCK.ToolButton4Click(Sender: TObject);
var
  fPrintFile:string;
begin
  if Order_Main.IsEmpty then Exit;
  if Trim(Order_Main.fieldbyname('Chker').AsString)='' then exit;
  fPrintFile:=ExtractFilePath(Application.ExeName)+'Report\退货单.rmf';
  RMXLSExport2:= TRMXLSExport.Create(RMXLSExport2);
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add(' select A.CRTime,A.GFOrderNo,A.filler,A.Editer,A.MYType,A.RKNo,A.KHName,A.JCDanWei,A.MYTypeFlag');
    SQL.ADD(',Sum(PS) PS,Sum(KgQty) KgQty,Sum(Qty) Qty,Sum(MYMDMoney) MYMDMoney ');
    sql.add(',IFFZ=(select Count(B.WBID) from TP_File B where B.WBID=A.RKNo and B.TFType=''退货棉'')');
    sql.Add(',KHNameJC=(select Top 1 B.KHNameJC from KH_Main B ');
    sql.Add(' where isnull(B.KHFlag,'''')=''GYS'' and isnull(B.Valid,'''')=''Y'' and B.KHName=A.KHName)');
    sql.Add(',JCDanWeiJC=(select Top 1 B.KHNameJC from KH_Main B ');
    sql.Add(' where isnull(B.KHFlag,'''')=''GS'' and isnull(B.Valid,'''')=''Y'' and B.KHName=A.JCDanWei)');
    sql.Add(',KHNo=(select Top 1 B.KHNo from KH_Main B ');
    sql.Add(' where isnull(B.KHFlag,'''')=''GYS'' and isnull(B.Valid,'''')=''Y'' and B.KHName=A.KHName)');
    sql.Add(',JCKHNo=(select Top 1 B.KHNo from KH_Main B ');
    sql.Add(' where isnull(B.KHFlag,'''')=''GYS'' and isnull(B.Valid,'''')=''Y'' and B.KHName=A.JCDanWei)');
    sql.Add(' from CK_MYSC_CR A  ');
    sql.Add(' where RKNo='''+trim(Order_Main.fieldbyname('RKNo').AsString)+''' ');
    sql.Add(' and isnull(CRType,'''')=''退货出库'' ');
    SQL.Add(' and isnull(MYType,'''')=''退货棉''');
    SQL.Add(' group by A.CRTime,A.GFOrderNo,A.RKNo,A.filler,A.Editer,A.MYType,A.KHName,A.JCDanWei,A.MYTypeFlag');
    Open;
  end;
  SCreateCDS20(ADOQueryTemp,CDS_PRT);
  SInitCDSData20(ADOQueryTemp,CDS_PRT);
  if FileExists(fPrintFile) then
  begin
    //RMVariables['OrderUnit']:=Order_Main.fieldbyname('OrderUnit').Value;
    RM1.LoadFromFile(fPrintFile);
    RM1.ShowReport;
  end  else
  begin
    Application.MessageBox(PChar('没有找'+ExtractFilePath(Application.ExeName)+'Report\退货单.rmf'),'提示',0);
  end;
end;

procedure TfrmMCGRKList_THCK.Tv1DblClick(Sender: TObject);
begin
  if Tv1.Controller.FocusedColumn.DataBinding.FilterFieldName='IFFZ' then
  begin
    cxGroupBox2.Visible:=true;
    Initimage();
  end
  else
  ToolButton1.Click;
end;

procedure TfrmMCGRKList_THCK.Image2Click(Sender: TObject);
begin
  Panel2.Visible:=False;
end;

procedure TfrmMCGRKList_THCK.SpeedButton1Click(Sender: TObject);
var FKHName,FKHNO:string;
begin
  Panel2.Visible:=False;
  try
    frmGYSList:=TfrmGYSList.Create(Application);
    with frmGYSList do
    begin
      KHType.Text:='棉厂';
      KHType.TxtCode:='棉厂';
      if ShowModal=1 then
      begin
        FKHName:=Trim(frmGYSList.Order_Main.fieldbyname('KHNameJC').AsString);
        FKHNO:=Trim(frmGYSList.Order_Main.fieldbyname('KHNo').AsString);
      end;
    end;
  finally
    frmGYSList.Free;
  end;
  try
    frmLLRKInPutMH_MTHCK:=TfrmLLRKInPutMH_MTHCK.Create(Application);
    with frmLLRKInPutMH_MTHCK do
    begin
      PState:=0;
      FMainId:='';
      FMYType:='退货棉';
      FMYTypeFlag:='CGH';
      labMYType.Caption:='(棉)退货';
      FML:='棉';
      frmPMCGRKList_CX:=TfrmPMCGRKList_CX.create(self);
      with frmPMCGRKList_CX do
      begin
        KHNo.Text:=Trim(FKHNO);
        KHNameJC.Text:=Trim(FKHName);
        CheckBox1.Checked:=true;
        if showmodal=1 then
        begin
          frmLLRKInPutMH_MTHCK.KHName.Text:=Trim(Order_Main.fieldbyname('KHName').AsString);
          frmLLRKInPutMH_MTHCK.KHNo.Text:=Trim(Order_Main.fieldbyname('KHNo').AsString);
          frmLLRKInPutMH_MTHCK.MYName.Text:=Trim(Order_Main.fieldbyname('MYName').AsString);
          frmLLRKInPutMH_MTHCK.MYCode.Text:=Trim(Order_Main.fieldbyname('MYCode').AsString);
          frmLLRKInPutMH_MTHCK.MYKZ.Text:=Trim(Order_Main.fieldbyname('MYKZ').AsString);
          frmLLRKInPutMH_MTHCK.MYMF.Text:=Trim(Order_Main.fieldbyname('MYMF').AsString);
          frmLLRKInPutMH_MTHCK.GFOrderNo.Text:=Trim(Order_Main.fieldbyname('GFOrderNo').AsString);
          frmLLRKInPutMH_MTHCK.PS.Text:=Trim(Order_Main.fieldbyname('PS').AsString);
          frmLLRKInPutMH_MTHCK.MDJChang.Text:=Trim(Order_Main.fieldbyname('MDJChang').AsString);
          frmLLRKInPutMH_MTHCK.MDKGFlag.Checked:=Order_Main.fieldbyname('MDKGFlag').AsBoolean;
          frmLLRKInPutMH_MTHCK.MDMFlag.Checked:=Order_Main.fieldbyname('MDMFlag').AsBoolean;
          frmLLRKInPutMH_MTHCK.HSFlag.Checked:=Order_Main.fieldbyname('HSFlag').AsBoolean;
          frmLLRKInPutMH_MTHCK.BHSFlag.Checked:=Order_Main.fieldbyname('BHSFlag').AsBoolean;
          frmLLRKInPutMH_MTHCK.MYMDPrice.Text:=Order_Main.fieldbyname('MYMDPrice').asstring;
          frmLLRKInPutMH_MTHCK.Price.Text:=floattostr(Order_Main.fieldbyname('Price').asfloat);
          frmLLRKInPutMH_MTHCK.FFZMYID:=Order_Main.fieldbyname('FZMYID').asstring;
        end;
        free;
      end;
      if ShowModal=1 then
      begin
        InitGrid();
      end;
    end;
  finally
    frmLLRKInPutMH_MTHCK.Free;
  end;
end;

procedure TfrmMCGRKList_THCK.SpeedButton2Click(Sender: TObject);
begin
  Panel2.Visible:=False;
  try
    frmLLRKInPut_CG:=TfrmLLRKInPut_CG.Create(Application);
    with frmLLRKInPut_CG do
    begin
      PState:=0;
      FMainId:='';
      FMYType:='采购面料';
      FMYTypeFlag:='CGM';
      labMYType.Caption:='(面料)采购';
      FML:='面料';
      if ShowModal=1 then
      begin
        InitGrid();
      end;
    end;
  finally
    frmLLRKInPut_CG.Free;
  end;
end;

procedure TfrmMCGRKList_THCK.SpeedButton4Click(Sender: TObject);
begin
  Panel2.Visible:=False;
  try
    frmLLRKInPutMH_CG:=TfrmLLRKInPutMH_CG.Create(Application);
    with frmLLRKInPutMH_CG do
    begin
      PState:=0;
      FMainId:='';
      FMYType:='退货棉';
      FMYTypeFlag:='CGH';
      labMYType.Caption:='(棉)采购';
      FML:='棉';
      if ShowModal=1 then
      begin
        InitGrid();
      end;
    end;
  finally
    frmLLRKInPutMH_CG.Free;
  end;
end;

procedure TfrmMCGRKList_THCK.SpeedButton5Click(Sender: TObject);
begin
  Panel2.Visible:=False;
  try
    frmLLRKInPutMH_CG:=TfrmLLRKInPutMH_CG.Create(Application);
    with frmLLRKInPutMH_CG do
    begin
      PState:=0;
      FMainId:='';
      FMYType:='采购无纺布';
      FMYTypeFlag:='CGW';
      labMYType.Caption:='(无纺布)采购';
      FML:='无纺布';
      if ShowModal=1 then
      begin
        InitGrid();
      end;
    end;
  finally
    frmLLRKInPutMH_CG.Free;
  end;
end;

procedure TfrmMCGRKList_THCK.SpeedButton3Click(Sender: TObject);
begin
  Panel2.Visible:=False;
  try
    frmLLRKInPut_CG:=TfrmLLRKInPut_CG.Create(Application);
    with frmLLRKInPut_CG do
    begin
      PState:=0;
      FMainId:='';
      FMYType:='采购线';
      FMYTypeFlag:='CGX';
      labMYType.Caption:='(线)采购';
      FML:='线';
      if ShowModal=1 then
      begin
        InitGrid();
      end;
    end;
  finally
    frmLLRKInPut_CG.Free;
  end;
end;

procedure TfrmMCGRKList_THCK.SpeedButton6Click(Sender: TObject);
begin
  Panel2.Visible:=False;
  try
    frmLLRKInPut_CG:=TfrmLLRKInPut_CG.Create(Application);
    with frmLLRKInPut_CG do
    begin
      PState:=0;
      FMainId:='';
      FMYType:='采购成品';
      FMYTypeFlag:='CGC';
      labMYType.Caption:='采购(成品)';
      FML:='成品';
      if ShowModal=1 then
      begin
        InitGrid();
      end;
    end;
  finally
    frmLLRKInPut_CG.Free;
  end;
end;

procedure TfrmMCGRKList_THCK.Button2Click(Sender: TObject);
begin
  try
    frmGYSList:=TfrmGYSList.Create(Application);
    with frmGYSList do
    begin
      KHType.Text:='棉厂';
      KHType.TxtCode:='棉厂';
      if ShowModal=1 then
      begin
        Self.KHNameJC.Text:=Trim(frmGYSList.Order_Main.fieldbyname('KHNameJC').AsString);
        TBFind.Click;
      end;
    end;
  finally
    frmGYSList.Free;
  end;
end;

procedure TfrmMCGRKList_THCK.Button1Click(Sender: TObject);
begin
  try
    frmGYSList:=TfrmGYSList.Create(Application);
    with frmGYSList do
    begin
      KHType.Text:='绣花厂';
      KHType.TxtCode:='绣花厂';
      if ShowModal=1 then
      begin
        Self.JCDanWeiJC.Text:=Trim(frmGYSList.Order_Main.fieldbyname('KHNameJC').AsString);
        TBFind.Click;
      end;
    end;
  finally
    frmGYSList.Free;
  end;
end;

procedure TfrmMCGRKList_THCK.Button3Click(Sender: TObject);
begin
  frmBPZDY_LRM:=TfrmBPZDY_LRM.create(self);
  with frmBPZDY_LRM do
  begin
    flag:='MName';
    flagName:='棉';
    ViewFlag:=true;
    Panel4.Align:=alClient;
    ToolBar3.Visible:=false;
    Button1.Visible:=False;
    if ShowModal=1 then
    begin
      MYName.text:=Trim(ClientDataSet1.fieldbyname('BPName').AsString);
    end;
    free;
  end;
end;

procedure TfrmMCGRKList_THCK.Initimage();
var
  ListItem: TListItem;
  Flag: Cardinal;
  info: SHFILEINFOA;
  Icon: TIcon;
begin
  ListView1.Items.Clear;
  with adoqueryTemp do
  begin
    close;
    sql.Clear;
    sql.Add('select fileName from TP_File ');
    sql.Add('where WBID='''+trim(Order_Main.fieldbyname('RKNo').AsString)+''' ');
    sql.Add('and TFType=''退货棉''');
    open;
    if not IsEmpty then
    begin
      while not eof do
      begin
        with ListView1 do
        begin
           LargeImages := ImageList1;
           Icon := TIcon.Create;
           ListItem := Items.Add;
           Listitem.Caption := trim(fieldbyname('fileName').AsString);
           Flag := (SHGFI_LARGEICON or SHGFI_ICON or SHGFI_USEFILEATTRIBUTES);
           SHGetFileInfo(Pchar(trim(fieldbyname('fileName').AsString)), 0, info, Sizeof(info), Flag);
           Icon.Handle := info.hIcon;
           ImageList1.AddIcon(Icon);
           ListItem.ImageIndex := ImageList1.Count - 1;
        end;
        next;
      end;
    end;
  end;
end;

procedure TfrmMCGRKList_THCK.Button4Click(Sender: TObject);
var
  fFileName:string;
  fFilePath:string;
  maxNo:string;
begin
  try
    adoqueryCmd.Connection.BeginTrans;
    begin
      fFilePath:=WJPach.Text;
      fFileName:=WJName.Text;
      with adoqueryCmd do
      begin
        close;
        sql.Clear;
        sql.Add('select TFId from TP_File ');
        sql.Add('where WBID='''+trim(Order_Main.fieldbyname('RKNo').AsString)+'''');
        sql.Add(' and TFType=''退货棉''');
        sql.Add(' and FileName='+quotedstr(trim(fFileName)));
        open;
      end;
      IF ADOQueryCmd.IsEmpty=False  then
      begin
        ADOQueryCmd.Connection.RollbackTrans;
        application.MessageBox('此附件名称已存在，请修改文件名，继续上传！','提示信息',MB_ICONERROR);
        exit;
      end;
      Panel12.Visible:=False;
      Panel2.Caption:='正在上传数据，请稍等...';
      Panel2.Visible:=true;
      application.ProcessMessages;

      if GetLSNo(ADOQueryCmd,maxNo,'MD','TP_File',4,1)=False then
      begin
        ADOQueryCmd.Connection.RollbackTrans;
        Application.MessageBox('取最大号失败！','提示',0);
        Exit;
      end;

      with adoqueryCmd do
      begin
        close;
        sql.Clear;
        sql.Add('delete from TP_File ');
        sql.Add('where WBID='''+trim(Order_Main.fieldbyname('RKNo').AsString)+'''');
        sql.Add('and TFType=''退货棉''');
        sql.Add('and FileName='+quotedstr(trim(fFileName)));
        execsql;
      end;
      with adoqueryCmd do
      begin
        close;
        sql.Clear;
        sql.Add('select * from TP_File ');
        sql.Add('where WBID='''+trim(Order_Main.fieldbyname('RKNo').AsString)+'''');
        sql.Add('and TFType=''退货棉''');
        sql.Add('and FileName='+quotedstr(trim(fFileName)));
        open;
        append;
        fieldbyname('TFID').Value:=trim(maxNO);
        fieldbyname('WBID').Value:=trim(Order_Main.fieldbyname('RKNo').AsString);
        fieldbyname('TFType').Value:='退货棉';
        fieldbyname('FileName').Value:=trim(fFileName);
        post;
      end;
      if fFilePath <> '' then
      begin
        try
          IdFTP1.Host := ReadINIFileStr('SYSTEMSET.INI','SERVER','服务器地址','127.0.0.1');
          IdFTP1.Username := 'three';
          IdFTP1.Password := '641010';
          IdFTP1.Connect();
          IdFTP1.Put(fFilePath, 'FJ\' + Trim(fFileName));
          IdFTP1.Quit;
        except
          IdFTP1.Quit;
          Application.MessageBox('上传文件失败，请检查文件服务器！', '提示', MB_ICONWARNING);
        end;
      end;
      IdFTP1.Quit;
      Panel2.Visible:=false;
      Initimage();
    end;
    adoqueryCmd.Connection.CommitTrans;
  except
    adoqueryCmd.Connection.RollbackTrans;
    application.MessageBox('文件保存失败！','提示信息',0);
  end;
end;

procedure TfrmMCGRKList_THCK.Button8Click(Sender: TObject);
var
  fFileName:String;
begin
  fFileName:=WJName.Hint;
  with ADOQueryCmd do
  begin
    close;
    sql.Clear;
    sql.Add('UPdate TP_File Set FileName='''+Trim(WJName.Text)+'''');
    sql.Add('where WBID='''+trim(Order_Main.fieldbyname('RKNo').AsString)+'''');
    sql.Add('and TFType=''退货棉''');
    sql.Add('and FileName='+quotedstr(trim(fFileName)));
    execsql;
  end;
  Panel12.Visible:=False;
  Initimage();
end;

procedure TfrmMCGRKList_THCK.Button7Click(Sender: TObject);
var
  fFileName:string;
  fFilePath:string;
  maxNo:string;
begin
  try
    adoqueryCmd.Connection.BeginTrans;
    fFilePath:=WJPach.Text;
    fFileName:=WJName.Hint;
    with adoqueryCmd do
    begin
      close;
      sql.Clear;
      sql.Add('select TFId from TP_File ');
      sql.Add('where WBID='''+trim(Order_Main.fieldbyname('RKNo').AsString)+'''');
      sql.Add('and TFType=''退货棉''');
      sql.Add('and FileName='+quotedstr(trim(fFileName)));
      open;
      IF not adoqueryCmd.IsEmpty then
      begin
        ADOQueryCmd.Connection.RollbackTrans;
        application.MessageBox('此附件名称已存在，请修改文件名，继续上传！','提示信息',MB_ICONERROR);
        exit;
      end;
    end;
    Panel12.Visible:=False;
    Panel2.Caption:='正在上传数据，请稍等...';
    Panel2.Visible:=true;
    application.ProcessMessages;

    if GetLSNo(ADOQueryCmd,maxNo,'FJ','TP_File',4,1)=False then
    begin
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('取最大号失败！','提示',0);
      Exit;
    end;

    with adoqueryCmd do
    begin
      close;
      sql.Clear;
      sql.Add('delete from TP_File ');
      sql.Add('where WBID='''+trim(Order_Main.fieldbyname('RKNo').AsString)+'''');
      sql.Add('and TFType=''退货棉''');
      sql.Add('and FileName='+quotedstr(trim(fFileName)));
      execsql;
    end;
    with adoqueryCmd do
    begin
      close;
      sql.Clear;
      sql.Add('select * from TP_File ');
      sql.Add('where WBID='''+trim(Order_Main.fieldbyname('RKNo').AsString)+'''');
      sql.Add('and TFType=''退货棉''');
      sql.Add('and FileName='+quotedstr(trim(fFileName)));
      open;
      append;
      fieldbyname('TFID').Value:=trim(maxNO);
      fieldbyname('WBID').Value:=trim(Order_Main.fieldbyname('RKNo').AsString);
      fieldbyname('TFType').Value:='退货棉';
      fieldbyname('FileName').Value:=trim(fFileName);
      post;
    end;
    if fFilePath <> '' then
    begin
      try
        IdFTP1.Host := ReadINIFileStr('SYSTEMSET.INI','SERVER','服务器地址','127.0.0.1');
        IdFTP1.Username := 'three';
        IdFTP1.Password := '641010';
        IdFTP1.Connect();
        IdFTP1.Put(fFilePath, 'FJ\' + Trim(fFileName));
        IdFTP1.Quit;
      except
        IdFTP1.Quit;
        Application.MessageBox('上传文件失败，请检查文件服务器！', '提示', MB_ICONWARNING);
      end;
    end;
    IdFTP1.Quit;
    Panel2.Visible:=false;
    Initimage();
    adoqueryCmd.Connection.CommitTrans;
  except
    adoqueryCmd.Connection.RollbackTrans;
    application.MessageBox('文件保存失败！','提示信息',0);
  end;
end;

procedure TfrmMCGRKList_THCK.Image1Click(Sender: TObject);
begin
  Panel12.Visible:=false;
end;

procedure TfrmMCGRKList_THCK.MenuItem1Click(Sender: TObject);
var
  OpenDiaLog: TOpenDialog;
  fFileName:string;
  fFilePath:string;
begin
  OpenDiaLog := TOpenDialog.Create(Self);
  if OpenDiaLog.Execute then
  begin
    fFilePath:=OpenDiaLog.FileName;
    fFileName:=ExtractFileName(OpenDiaLog.FileName);
    Panel12.Visible:=True;
    WJName.Text:=Trim(fFileName);
    WJName.Hint:=Trim(fFileName);
    WJPach.Text:=fFilePath;
    Button8.Visible:=False;
    Button4.Visible:=True;
    Button7.Visible:=True;
    Panel12.Refresh;
  end;
end;

procedure TfrmMCGRKList_THCK.N3Click(Sender: TObject);
var
  fFileName:string;
begin
  if listView1.SelCount<1 then exit;
  fFileName:=ListView1.Selected.Caption;
  with ADOQueryCmd do
  begin
    close;
    sql.Clear;
    sql.Add('delete  from TP_File ');
    sql.Add('where WBID='''+trim(Order_Main.fieldbyname('RKNo').AsString)+'''');
    sql.Add('and TFType=''退货棉''');
    sql.Add('and FileName='+quotedstr(trim(fFileName)));
    execsql;
  end;
  Initimage();
end;

procedure TfrmMCGRKList_THCK.Image3Click(Sender: TObject);
begin
  cxGroupBox2.Visible:=false;
end;

procedure TfrmMCGRKList_THCK.ListView1DblClick(Sender: TObject);
var
  sFieldName:string;
  fileName:string;
begin
  if ListView1.Items.Count<1 THEN EXIT;

  if listView1.SelCount<1 then exit;
  sFieldName:=leftbstr(ExtractFilePath(Application.ExeName),1)+':\图片查看';

  if not DirectoryExists(pchar(sFieldName)) then
  CreateDirectory(pchar(sFieldName),nil);

  fileName:=ListView1.Selected.Caption;

  sFieldName:=sFieldName+'\'+trim(fileName);

  try
    IdFTP1.Host := ReadINIFileStr('SYSTEMSET.INI','SERVER','服务器地址','127.0.0.1');
    IdFTP1.Username := 'three';
		IdFTP1.Password := '641010';
    IdFTP1.Connect();
  except
    ;
  end;

  if IdFTP1.Connected then
  begin

      Panel2.Caption:='正在下载数据，请稍等...';
      Panel2.Visible:=true;
      application.ProcessMessages;
    try
      IdFTP1.Get('FJ\'+ Trim(fileName), sFieldName,true, false);
    except
      Panel2.Visible:=false;
      Application.MessageBox('客户图样文件不存在', '提示', MB_ICONWARNING);
      IdFTP1.Quit;
      Exit;
    end;
  end
  else
  begin
    Panel2.Visible:=false;
    Application.MessageBox('无法连接文件服务器', '提示', MB_ICONWARNING);
    IdFTP1.Quit;
    Exit;
  end;
  Panel2.Visible:=false;
   if IdFTP1.Connected then IdFTP1.Quit;
  ShellExecute(Handle, 'open',PChar(sFieldName),'', '', SW_SHOWNORMAL);
end;

procedure TfrmMCGRKList_THCK.N4Click(Sender: TObject);
var
  SaveDialog: TSaveDialog;
  fFileName:string;
  fFilePath:string;
begin
  if listView1.SelCount<1 then exit;
  try
    fFileName:=ListView1.Selected.Caption;
    SaveDialog := TSaveDialog.Create(Self);
    SaveDialog.FileName:=fFileName;
    if SaveDialog.Execute then
    begin
      Panel2.Caption:='正在保存数据，请稍等...';
      Panel2.Visible:=true;
      application.ProcessMessages;
      fFilePath:=SaveDialog.FileName;
      try
        IdFTP1.Host := ReadINIFileStr('SYSTEMSET.INI','SERVER','FTP地址','127.0.0.1');;
        IdFTP1.Username := 'three';
		    IdFTP1.Password := '641010';
        IdFTP1.Connect();
      except
        ;
      end;

      if IdFTP1.Connected then
      begin
        Panel2.Caption:='正在下载数据，请稍等...';
        Panel2.Visible:=true;
        application.ProcessMessages;
        try
         IdFTP1.Get('FJ\'+ Trim(fFileName), fFilePath,false, true);
        except
          Panel2.Visible:=false;
          Application.MessageBox('客户图样文件不存在', '提示', MB_ICONWARNING);
          IdFTP1.Quit;
          Exit;
        end;
      end else
      begin
        Panel2.Visible:=false;
        Application.MessageBox('无法连接文件服务器', '提示', MB_ICONWARNING);
        IdFTP1.Quit;
        Exit;
      end;
     Panel2.Visible:=false;
     if IdFTP1.Connected then IdFTP1.Quit;
    end;
  except
    Panel2.Visible:=false;
  end;
end;

procedure TfrmMCGRKList_THCK.MenuItem2Click(Sender: TObject);
begin
  if listView1.SelCount<1 then exit;
  Panel12.Visible:=True;
  Button4.Visible:=False;
  Button7.Visible:=False;
  Button8.Visible:=True;
  Panel12.Refresh;
  WJName.Text:=Trim(ListView1.Selected.Caption);
  WJName.Hint:=Trim(ListView1.Selected.Caption);
end;

procedure TfrmMCGRKList_THCK.N5Click(Sender: TObject);
begin
  cxGroupBox2.Visible:=true;
end;

end.
